From c804adf4b64a5755c885b681c32591d2e67aa636 Mon Sep 17 00:00:00 2001
From: "kaf24@firebug.cl.cam.ac.uk" <kaf24@firebug.cl.cam.ac.uk>
Date: Thu, 6 Oct 2005 16:07:52 +0100
Subject: Change how event channels are allocated and used by the control
 tools. /dev/xen/evtchn is now used by daemons to connect to remote domains:
 the advantage is that the local ports are garbage collected automatically if
 the daemon dies. xen no longer constructs end-to-end event-channel port pairs
 -- it allocates an unbound port in new domU and writes that port to xenstore.
 It is then picked up by teh appropriate daemon which does interdomain bind
 via /dev/xen/evtchn.

Signed-off-by: Keir Fraser <keir@xensource.com>
---
 tools/xenstore/xenstored_domain.c | 36 +++++++++++++++++++++++-------------
 1 file changed, 23 insertions(+), 13 deletions(-)

(limited to 'tools/xenstore')

diff --git a/tools/xenstore/xenstored_domain.c b/tools/xenstore/xenstored_domain.c
index 9ac1b28eef..69ace083d9 100644
--- a/tools/xenstore/xenstored_domain.c
+++ b/tools/xenstore/xenstored_domain.c
@@ -36,6 +36,8 @@
 #include "xenstored_watch.h"
 #include "xenstored_test.h"
 
+#include <xen/linux/evtchn.h>
+
 static int *xc_handle;
 static int eventchn_fd;
 static int virq_port;
@@ -77,9 +79,6 @@ struct ringbuf_head
 	char buf[0];
 } __attribute__((packed));
 
-#define EVENTCHN_BIND		_IO('E', 2)
-#define EVENTCHN_UNBIND 	_IO('E', 3)
-
 /* FIXME: Mark connection as broken (close it?) when this happens. */
 static bool check_buffer(const struct ringbuf_head *h)
 {
@@ -207,14 +206,17 @@ static int readchn(struct connection *conn, void *data, unsigned int len)
 static int destroy_domain(void *_domain)
 {
 	struct domain *domain = _domain;
+	struct ioctl_evtchn_unbind unbind;
 
 	list_del(&domain->list);
 
-	if (domain->port &&
-	    (ioctl(eventchn_fd, EVENTCHN_UNBIND, domain->port) != 0))
-		eprintf("> Unbinding port %i failed!\n", domain->port);
+	if (domain->port) {
+		unbind.port = domain->port;
+		if (ioctl(eventchn_fd, IOCTL_EVTCHN_UNBIND, &unbind) == -1)
+			eprintf("> Unbinding port %i failed!\n", domain->port);
+	}
 
-	if(domain->page)
+	if (domain->page)
 		munmap(domain->page, getpagesize());
 
 	return 0;
@@ -278,6 +280,9 @@ static struct domain *new_domain(void *context, domid_t domid,
 				 const char *path)
 {
 	struct domain *domain;
+	struct ioctl_evtchn_bind_interdomain bind;
+	int rc;
+
 	domain = talloc(context, struct domain);
 	domain->port = 0;
 	domain->shutdown = 0;
@@ -298,10 +303,13 @@ static struct domain *new_domain(void *context, domid_t domid,
 	domain->output = domain->page + getpagesize()/2;
 
 	/* Tell kernel we're interested in this event. */
-	if (ioctl(eventchn_fd, EVENTCHN_BIND, port) != 0)
+	bind.remote_domain = domid;
+	bind.remote_port   = port;
+	rc = ioctl(eventchn_fd, IOCTL_EVTCHN_BIND_INTERDOMAIN, &bind);
+	if (rc == -1)
 		return NULL;
 
-	domain->port = port;
+	domain->port = rc;
 	domain->conn = new_connection(writechn, readchn);
 	domain->conn->domain = domain;
 	return domain;
@@ -445,6 +453,8 @@ void restore_existing_connections(void)
 int domain_init(void)
 {
 	struct stat st;
+	struct ioctl_evtchn_bind_virq bind;
+	int rc;
 
 	/* The size of the ringbuffer: half a page minus head structure. */
 	ringbuf_datasize = getpagesize() / 2 - sizeof(struct ringbuf_head);
@@ -482,11 +492,11 @@ int domain_init(void)
 	if (eventchn_fd < 0)
 		barf_perror("Failed to open evtchn device");
 
-	if (xc_evtchn_bind_virq(*xc_handle, VIRQ_DOM_EXC, &virq_port))
-		barf_perror("Failed to bind to domain exception virq");
-
-	if (ioctl(eventchn_fd, EVENTCHN_BIND, virq_port) != 0)
+	bind.virq = VIRQ_DOM_EXC;
+	rc = ioctl(eventchn_fd, IOCTL_EVTCHN_BIND_VIRQ, &bind);
+	if (rc == -1)
 		barf_perror("Failed to bind to domain exception virq port");
+	virq_port = rc;
 
 	return eventchn_fd;
 }
-- 
cgit v1.2.3

>patches</a>/<a href='/cgit.cgi/openwrt/upstream/tree/package/utils/lua/patches/300-opcode_performance.patch?id=1b13b3523198230825faf097b2abea0345e0cb35'>300-opcode_performance.patch</a></div><div class='content'>blob: 5fbb87388a6598bfed969fbeff4ff808409f2745 (<a href='/cgit.cgi/openwrt/upstream/plain/package/utils/lua/patches/300-opcode_performance.patch?id=1b13b3523198230825faf097b2abea0345e0cb35'>plain</a>)
<table summary='blob content' class='blob'>
<tr><td class='linenumbers'><pre><a id='n1' href='#n1'>1</a>
<a id='n2' href='#n2'>2</a>
<a id='n3' href='#n3'>3</a>
<a id='n4' href='#n4'>4</a>
<a id='n5' href='#n5'>5</a>
<a id='n6' href='#n6'>6</a>
<a id='n7' href='#n7'>7</a>
<a id='n8' href='#n8'>8</a>
<a id='n9' href='#n9'>9</a>
<a id='n10' href='#n10'>10</a>
<a id='n11' href='#n11'>11</a>
<a id='n12' href='#n12'>12</a>
<a id='n13' href='#n13'>13</a>
<a id='n14' href='#n14'>14</a>
<a id='n15' href='#n15'>15</a>
<a id='n16' href='#n16'>16</a>
<a id='n17' href='#n17'>17</a>
<a id='n18' href='#n18'>18</a>
<a id='n19' href='#n19'>19</a>
<a id='n20' href='#n20'>20</a>
<a id='n21' href='#n21'>21</a>
<a id='n22' href='#n22'>22</a>
<a id='n23' href='#n23'>23</a>
<a id='n24' href='#n24'>24</a>
<a id='n25' href='#n25'>25</a>
<a id='n26' href='#n26'>26</a>
<a id='n27' href='#n27'>27</a>
<a id='n28' href='#n28'>28</a>
<a id='n29' href='#n29'>29</a>
<a id='n30' href='#n30'>30</a>
<a id='n31' href='#n31'>31</a>
<a id='n32' href='#n32'>32</a>
<a id='n33' href='#n33'>33</a>
<a id='n34' href='#n34'>34</a>
<a id='n35' href='#n35'>35</a>
<a id='n36' href='#n36'>36</a>
<a id='n37' href='#n37'>37</a>
<a id='n38' href='#n38'>38</a>
<a id='n39' href='#n39'>39</a>
<a id='n40' href='#n40'>40</a>
<a id='n41' href='#n41'>41</a>
<a id='n42' href='#n42'>42</a>
<a id='n43' href='#n43'>43</a>
<a id='n44' href='#n44'>44</a>
<a id='n45' href='#n45'>45</a>
<a id='n46' href='#n46'>46</a>
<a id='n47' href='#n47'>47</a>
<a id='n48' href='#n48'>48</a>
<a id='n49' href='#n49'>49</a>
<a id='n50' href='#n50'>50</a>
<a id='n51' href='#n51'>51</a>
<a id='n52' href='#n52'>52</a>
<a id='n53' href='#n53'>53</a>
<a id='n54' href='#n54'>54</a>
<a id='n55' href='#n55'>55</a>
<a id='n56' href='#n56'>56</a>
<a id='n57' href='#n57'>57</a>
<a id='n58' href='#n58'>58</a>
<a id='n59' href='#n59'>59</a>
<a id='n60' href='#n60'>60</a>
<a id='n61' href='#n61'>61</a>
<a id='n62' href='#n62'>62</a>
<a id='n63' href='#n63'>63</a>
<a id='n64' href='#n64'>64</a>
<a id='n65' href='#n65'>65</a>
<a id='n66' href='#n66'>66</a>
<a id='n67' href='#n67'>67</a>
<a id='n68' href='#n68'>68</a>
<a id='n69' href='#n69'>69</a>
<a id='n70' href='#n70'>70</a>
<a id='n71' href='#n71'>71</a>
<a id='n72' href='#n72'>72</a>
<a id='n73' href='#n73'>73</a>
<a id='n74' href='#n74'>74</a>
<a id='n75' href='#n75'>75</a>
<a id='n76' href='#n76'>76</a>
<a id='n77' href='#n77'>77</a>
<a id='n78' href='#n78'>78</a>
<a id='n79' href='#n79'>79</a>
<a id='n80' href='#n80'>80</a>
<a id='n81' href='#n81'>81</a>
<a id='n82' href='#n82'>82</a>
<a id='n83' href='#n83'>83</a>
<a id='n84' href='#n84'>84</a>
<a id='n85' href='#n85'>85</a>
<a id='n86' href='#n86'>86</a>
<a id='n87' href='#n87'>87</a>
<a id='n88' href='#n88'>88</a>
<a id='n89' href='#n89'>89</a>
<a id='n90' href='#n90'>90</a>
<a id='n91' href='#n91'>91</a>
<a id='n92' href='#n92'>92</a>
<a id='n93' href='#n93'>93</a>
<a id='n94' href='#n94'>94</a>
<a id='n95' href='#n95'>95</a>
<a id='n96' href='#n96'>96</a>
<a id='n97' href='#n97'>97</a>
<a id='n98' href='#n98'>98</a>
<a id='n99' href='#n99'>99</a>
<a id='n100' href='#n100'>100</a>
<a id='n101' href='#n101'>101</a>
<a id='n102' href='#n102'>102</a>
<a id='n103' href='#n103'>103</a>
<a id='n104' href='#n104'>104</a>
<a id='n105' href='#n105'>105</a>
<a id='n106' href='#n106'>106</a>
<a id='n107' href='#n107'>107</a>
<a id='n108' href='#n108'>108</a>
<a id='n109' href='#n109'>109</a>
<a id='n110' href='#n110'>110</a>
<a id='n111' href='#n111'>111</a>
<a id='n112' href='#n112'>112</a>
<a id='n113' href='#n113'>113</a>
<a id='n114' href='#n114'>114</a>
<a id='n115' href='#n115'>115</a>
<a id='n116' href='#n116'>116</a>
<a id='n117' href='#n117'>117</a>
<a id='n118' href='#n118'>118</a>
<a id='n119' href='#n119'>119</a>
<a id='n120' href='#n120'>120</a>
<a id='n121' href='#n121'>121</a>
<a id='n122' href='#n122'>122</a>
<a id='n123' href='#n123'>123</a>
<a id='n124' href='#n124'>124</a>
<a id='n125' href='#n125'>125</a>
<a id='n126' href='#n126'>126</a>
<a id='n127' href='#n127'>127</a>
<a id='n128' href='#n128'>128</a>
<a id='n129' href='#n129'>129</a>
<a id='n130' href='#n130'>130</a>
<a id='n131' href='#n131'>131</a>
<a id='n132' href='#n132'>132</a>
<a id='n133' href='#n133'>133</a>
<a id='n134' href='#n134'>134</a>
<a id='n135' href='#n135'>135</a>
<a id='n136' href='#n136'>136</a>
<a id='n137' href='#n137'>137</a>
<a id='n138' href='#n138'>138</a>
<a id='n139' href='#n139'>139</a>
<a id='n140' href='#n140'>140</a>
<a id='n141' href='#n141'>141</a>
<a id='n142' href='#n142'>142</a>
<a id='n143' href='#n143'>143</a>
<a id='n144' href='#n144'>144</a>
<a id='n145' href='#n145'>145</a>
<a id='n146' href='#n146'>146</a>
<a id='n147' href='#n147'>147</a>
<a id='n148' href='#n148'>148</a>
<a id='n149' href='#n149'>149</a>
<a id='n150' href='#n150'>150</a>
<a id='n151' href='#n151'>151</a>
<a id='n152' href='#n152'>152</a>
<a id='n153' href='#n153'>153</a>
<a id='n154' href='#n154'>154</a>
<a id='n155' href='#n155'>155</a>
<a id='n156' href='#n156'>156</a>
<a id='n157' href='#n157'>157</a>
<a id='n158' href='#n158'>158</a>
<a id='n159' href='#n159'>159</a>
<a id='n160' href='#n160'>160</a>
<a id='n161' href='#n161'>161</a>
<a id='n162' href='#n162'>162</a>
<a id='n163' href='#n163'>163</a>
<a id='n164' href='#n164'>164</a>
<a id='n165' href='#n165'>165</a>
<a id='n166' href='#n166'>166</a>
<a id='n167' href='#n167'>167</a>
<a id='n168' href='#n168'>168</a>
<a id='n169' href='#n169'>169</a>
<a id='n170' href='#n170'>170</a>
<a id='n171' href='#n171'>171</a>
<a id='n172' href='#n172'>172</a>
<a id='n173' href='#n173'>173</a>
<a id='n174' href='#n174'>174</a>
<a id='n175' href='#n175'>175</a>
<a id='n176' href='#n176'>176</a>
<a id='n177' href='#n177'>177</a>
<a id='n178' href='#n178'>178</a>
<a id='n179' href='#n179'>179</a>
<a id='n180' href='#n180'>180</a>
<a id='n181' href='#n181'>181</a>
<a id='n182' href='#n182'>182</a>
<a id='n183' href='#n183'>183</a>
<a id='n184' href='#n184'>184</a>
<a id='n185' href='#n185'>185</a>
<a id='n186' href='#n186'>186</a>
<a id='n187' href='#n187'>187</a>
<a id='n188' href='#n188'>188</a>
<a id='n189' href='#n189'>189</a>
<a id='n190' href='#n190'>190</a>
<a id='n191' href='#n191'>191</a>
<a id='n192' href='#n192'>192</a>
<a id='n193' href='#n193'>193</a>
<a id='n194' href='#n194'>194</a>
<a id='n195' href='#n195'>195</a>
<a id='n196' href='#n196'>196</a>
<a id='n197' href='#n197'>197</a>
<a id='n198' href='#n198'>198</a>
<a id='n199' href='#n199'>199</a>
<a id='n200' href='#n200'>200</a>
<a id='n201' href='#n201'>201</a>
<a id='n202' href='#n202'>202</a>
<a id='n203' href='#n203'>203</a>
<a id='n204' href='#n204'>204</a>
<a id='n205' href='#n205'>205</a>
<a id='n206' href='#n206'>206</a>
<a id='n207' href='#n207'>207</a>
<a id='n208' href='#n208'>208</a>
<a id='n209' href='#n209'>209</a>
<a id='n210' href='#n210'>210</a>
<a id='n211' href='#n211'>211</a>
<a id='n212' href='#n212'>212</a>
<a id='n213' href='#n213'>213</a>
<a id='n214' href='#n214'>214</a>
<a id='n215' href='#n215'>215</a>
<a id='n216' href='#n216'>216</a>
<a id='n217' href='#n217'>217</a>
<a id='n218' href='#n218'>218</a>
<a id='n219' href='#n219'>219</a>
<a id='n220' href='#n220'>220</a>
<a id='n221' href='#n221'>221</a>
<a id='n222' href='#n222'>222</a>
<a id='n223' href='#n223'>223</a>
<a id='n224' href='#n224'>224</a>
<a id='n225' href='#n225'>225</a>
<a id='n226' href='#n226'>226</a>
<a id='n227' href='#n227'>227</a>
<a id='n228' href='#n228'>228</a>
<a id='n229' href='#n229'>229</a>
<a id='n230' href='#n230'>230</a>
<a id='n231' href='#n231'>231</a>
<a id='n232' href='#n232'>232</a>
<a id='n233' href='#n233'>233</a>
<a id='n234' href='#n234'>234</a>
<a id='n235' href='#n235'>235</a>
<a id='n236' href='#n236'>236</a>
<a id='n237' href='#n237'>237</a>
<a id='n238' href='#n238'>238</a>
<a id='n239' href='#n239'>239</a>
<a id='n240' href='#n240'>240</a>
<a id='n241' href='#n241'>241</a>
<a id='n242' href='#n242'>242</a>
<a id='n243' href='#n243'>243</a>
<a id='n244' href='#n244'>244</a>
<a id='n245' href='#n245'>245</a>
<a id='n246' href='#n246'>246</a>
<a id='n247' href='#n247'>247</a>
<a id='n248' href='#n248'>248</a>
<a id='n249' href='#n249'>249</a>
<a id='n250' href='#n250'>250</a>
<a id='n251' href='#n251'>251</a>
<a id='n252' href='#n252'>252</a>
<a id='n253' href='#n253'>253</a>
<a id='n254' href='#n254'>254</a>
<a id='n255' href='#n255'>255</a>
<a id='n256' href='#n256'>256</a>
<a id='n257' href='#n257'>257</a>
<a id='n258' href='#n258'>258</a>
<a id='n259' href='#n259'>259</a>
<a id='n260' href='#n260'>260</a>
<a id='n261' href='#n261'>261</a>
<a id='n262' href='#n262'>262</a>
<a id='n263' href='#n263'>263</a>
<a id='n264' href='#n264'>264</a>
<a id='n265' href='#n265'>265</a>
<a id='n266' href='#n266'>266</a>
<a id='n267' href='#n267'>267</a>
<a id='n268' href='#n268'>268</a>
<a id='n269' href='#n269'>269</a>
<a id='n270' href='#n270'>270</a>
<a id='n271' href='#n271'>271</a>
<a id='n272' href='#n272'>272</a>
<a id='n273' href='#n273'>273</a>
<a id='n274' href='#n274'>274</a>
<a id='n275' href='#n275'>275</a>
<a id='n276' href='#n276'>276</a>
<a id='n277' href='#n277'>277</a>
<a id='n278' href='#n278'>278</a>
<a id='n279' href='#n279'>279</a>
<a id='n280' href='#n280'>280</a>
<a id='n281' href='#n281'>281</a>
<a id='n282' href='#n282'>282</a>
<a id='n283' href='#n283'>283</a>
<a id='n284' href='#n284'>284</a>
<a id='n285' href='#n285'>285</a>
<a id='n286' href='#n286'>286</a>
<a id='n287' href='#n287'>287</a>
<a id='n288' href='#n288'>288</a>
<a id='n289' href='#n289'>289</a>
<a id='n290' href='#n290'>290</a>
<a id='n291' href='#n291'>291</a>
<a id='n292' href='#n292'>292</a>
<a id='n293' href='#n293'>293</a>
<a id='n294' href='#n294'>294</a>
<a id='n295' href='#n295'>295</a>
<a id='n296' href='#n296'>296</a>
<a id='n297' href='#n297'>297</a>
<a id='n298' href='#n298'>298</a>
<a id='n299' href='#n299'>299</a>
<a id='n300' href='#n300'>300</a>
<a id='n301' href='#n301'>301</a>
<a id='n302' href='#n302'>302</a>
<a id='n303' href='#n303'>303</a>
<a id='n304' href='#n304'>304</a>
<a id='n305' href='#n305'>305</a>
<a id='n306' href='#n306'>306</a>
<a id='n307' href='#n307'>307</a>
<a id='n308' href='#n308'>308</a>
<a id='n309' href='#n309'>309</a>
<a id='n310' href='#n310'>310</a>
<a id='n311' href='#n311'>311</a>
<a id='n312' href='#n312'>312</a>
<a id='n313' href='#n313'>313</a>
<a id='n314' href='#n314'>314</a>
<a id='n315' href='#n315'>315</a>
<a id='n316' href='#n316'>316</a>
<a id='n317' href='#n317'>317</a>
<a id='n318' href='#n318'>318</a>
<a id='n319' href='#n319'>319</a>
<a id='n320' href='#n320'>320</a>
<a id='n321' href='#n321'>321</a>
<a id='n322' href='#n322'>322</a>
<a id='n323' href='#n323'>323</a>
<a id='n324' href='#n324'>324</a>
<a id='n325' href='#n325'>325</a>
<a id='n326' href='#n326'>326</a>
<a id='n327' href='#n327'>327</a>
<a id='n328' href='#n328'>328</a>
<a id='n329' href='#n329'>329</a>
<a id='n330' href='#n330'>330</a>
<a id='n331' href='#n331'>331</a>
<a id='n332' href='#n332'>332</a>
<a id='n333' href='#n333'>333</a>
<a id='n334' href='#n334'>334</a>
<a id='n335' href='#n335'>335</a>
<a id='n336' href='#n336'>336</a>
<a id='n337' href='#n337'>337</a>
<a id='n338' href='#n338'>338</a>
<a id='n339' href='#n339'>339</a>
<a id='n340' href='#n340'>340</a>
<a id='n341' href='#n341'>341</a>
<a id='n342' href='#n342'>342</a>
<a id='n343' href='#n343'>343</a>
<a id='n344' href='#n344'>344</a>
<a id='n345' href='#n345'>345</a>
<a id='n346' href='#n346'>346</a>
<a id='n347' href='#n347'>347</a>
<a id='n348' href='#n348'>348</a>
<a id='n349' href='#n349'>349</a>
<a id='n350' href='#n350'>350</a>
<a id='n351' href='#n351'>351</a>
<a id='n352' href='#n352'>352</a>
<a id='n353' href='#n353'>353</a>
<a id='n354' href='#n354'>354</a>
<a id='n355' href='#n355'>355</a>
<a id='n356' href='#n356'>356</a>
<a id='n357' href='#n357'>357</a>
<a id='n358' href='#n358'>358</a>
<a id='n359' href='#n359'>359</a>
<a id='n360' href='#n360'>360</a>
<a id='n361' href='#n361'>361</a>
<a id='n362' href='#n362'>362</a>
<a id='n363' href='#n363'>363</a>
</pre></td>
<td class='lines'><pre><code><style>pre { line-height: 125%; margin: 0; }
td.linenos pre { color: #000000; background-color: #f0f0f0; padding: 0 5px 0 5px; }
span.linenos { color: #000000; background-color: #f0f0f0; padding: 0 5px 0 5px; }
td.linenos pre.special { color: #000000; background-color: #ffffc0; padding: 0 5px 0 5px; }
span.linenos.special { color: #000000; background-color: #ffffc0; padding: 0 5px 0 5px; }
.highlight .hll { background-color: #ffffcc }
.highlight { background: #ffffff; }
.highlight .c { color: #888888 } /* Comment */
.highlight .err { color: #a61717; background-color: #e3d2d2 } /* Error */
.highlight .k { color: #008800; font-weight: bold } /* Keyword */
.highlight .ch { color: #888888 } /* Comment.Hashbang */
.highlight .cm { color: #888888 } /* Comment.Multiline */
.highlight .cp { color: #cc0000; font-weight: bold } /* Comment.Preproc */
.highlight .cpf { color: #888888 } /* Comment.PreprocFile */
.highlight .c1 { color: #888888 } /* Comment.Single */
.highlight .cs { color: #cc0000; font-weight: bold; background-color: #fff0f0 } /* Comment.Special */
.highlight .gd { color: #000000; background-color: #ffdddd } /* Generic.Deleted */
.highlight .ge { font-style: italic } /* Generic.Emph */
.highlight .gr { color: #aa0000 } /* Generic.Error */
.highlight .gh { color: #333333 } /* Generic.Heading */
.highlight .gi { color: #000000; background-color: #ddffdd } /* Generic.Inserted */
.highlight .go { color: #888888 } /* Generic.Output */
.highlight .gp { color: #555555 } /* Generic.Prompt */
.highlight .gs { font-weight: bold } /* Generic.Strong */
.highlight .gu { color: #666666 } /* Generic.Subheading */
.highlight .gt { color: #aa0000 } /* Generic.Traceback */
.highlight .kc { color: #008800; font-weight: bold } /* Keyword.Constant */
.highlight .kd { color: #008800; font-weight: bold } /* Keyword.Declaration */
.highlight .kn { color: #008800; font-weight: bold } /* Keyword.Namespace */
.highlight .kp { color: #008800 } /* Keyword.Pseudo */
.highlight .kr { color: #008800; font-weight: bold } /* Keyword.Reserved */
.highlight .kt { color: #888888; font-weight: bold } /* Keyword.Type */
.highlight .m { color: #0000DD; font-weight: bold } /* Literal.Number */
.highlight .s { color: #dd2200; background-color: #fff0f0 } /* Literal.String */
.highlight .na { color: #336699 } /* Name.Attribute */
.highlight .nb { color: #003388 } /* Name.Builtin */
.highlight .nc { color: #bb0066; font-weight: bold } /* Name.Class */
.highlight .no { color: #003366; font-weight: bold } /* Name.Constant */
.highlight .nd { color: #555555 } /* Name.Decorator */
.highlight .ne { color: #bb0066; font-weight: bold } /* Name.Exception */
.highlight .nf { color: #0066bb; font-weight: bold } /* Name.Function */
.highlight .nl { color: #336699; font-style: italic } /* Name.Label */
.highlight .nn { color: #bb0066; font-weight: bold } /* Name.Namespace */
.highlight .py { color: #336699; font-weight: bold } /* Name.Property */
.highlight .nt { color: #bb0066; font-weight: bold } /* Name.Tag */
.highlight .nv { color: #336699 } /* Name.Variable */
.highlight .ow { color: #008800 } /* Operator.Word */
.highlight .w { color: #bbbbbb } /* Text.Whitespace */
.highlight .mb { color: #0000DD; font-weight: bold } /* Literal.Number.Bin */
.highlight .mf { color: #0000DD; font-weight: bold } /* Literal.Number.Float */
.highlight .mh { color: #0000DD; font-weight: bold } /* Literal.Number.Hex */
.highlight .mi { color: #0000DD; font-weight: bold } /* Literal.Number.Integer */
.highlight .mo { color: #0000DD; font-weight: bold } /* Literal.Number.Oct */
.highlight .sa { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Affix */
.highlight .sb { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Backtick */
.highlight .sc { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Char */
.highlight .dl { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Delimiter */
.highlight .sd { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Doc */
.highlight .s2 { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Double */
.highlight .se { color: #0044dd; background-color: #fff0f0 } /* Literal.String.Escape */
.highlight .sh { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Heredoc */
.highlight .si { color: #3333bb; background-color: #fff0f0 } /* Literal.String.Interpol */
.highlight .sx { color: #22bb22; background-color: #f0fff0 } /* Literal.String.Other */
.highlight .sr { color: #008800; background-color: #fff0ff } /* Literal.String.Regex */
.highlight .s1 { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Single */
.highlight .ss { color: #aa6600; background-color: #fff0f0 } /* Literal.String.Symbol */
.highlight .bp { color: #003388 } /* Name.Builtin.Pseudo */
.highlight .fm { color: #0066bb; font-weight: bold } /* Name.Function.Magic */
.highlight .vc { color: #336699 } /* Name.Variable.Class */
.highlight .vg { color: #dd7700 } /* Name.Variable.Global */
.highlight .vi { color: #3333bb } /* Name.Variable.Instance */
.highlight .vm { color: #336699 } /* Name.Variable.Magic */
.highlight .il { color: #0000DD; font-weight: bold } /* Literal.Number.Integer.Long */</style><div class="highlight"><pre><span></span><span class="gd">--- a/src/lvm.c</span>
<span class="gi">+++ b/src/lvm.c</span>
<span class="gu">@@ -31,6 +31,9 @@</span>
 /* limit for table tag-method chains (to avoid loops) */
 #define MAXTAGLOOP	100
 
<span class="gi">+#ifdef __GNUC__</span>
<span class="gi">+#define COMPUTED_GOTO 1</span>
<span class="gi">+#endif</span>
 
 /*
  * If &#39;obj&#39; is a string, it is tried to be interpreted as a number.
<span class="gu">@@ -566,12 +569,63 @@ static inline int arith_mode( const TVal</span>
     ARITH_OP1_END
 #endif
 
<span class="gi">+#ifdef COMPUTED_GOTO</span>
<span class="gi">+#define OPCODE_TARGET(op) DO_OP_##op:</span>
<span class="gi">+#define CALL_OPCODE(op) goto *opcodes[op];</span>
<span class="gi">+#define OPCODE_PTR(op) [OP_##op] = &amp;&amp;DO_OP_##op</span>
<span class="gi">+#else</span>
<span class="gi">+#define OPCODE_TARGET(op) case OP_##op:</span>
<span class="gi">+#define CALL_OPCODE(op) switch (op)</span>
<span class="gi">+#endif</span>
<span class="gi">+</span>
 
 void luaV_execute (lua_State *L, int nexeccalls) {
   LClosure *cl;
   StkId base;
   TValue *k;
   const Instruction *pc;
<span class="gi">+#ifdef COMPUTED_GOTO</span>
<span class="gi">+  static const void *opcodes[] = {</span>
<span class="gi">+   OPCODE_PTR(MOVE),</span>
<span class="gi">+   OPCODE_PTR(LOADK),</span>
<span class="gi">+   OPCODE_PTR(LOADBOOL),</span>
<span class="gi">+   OPCODE_PTR(LOADNIL),</span>
<span class="gi">+   OPCODE_PTR(GETUPVAL),</span>
<span class="gi">+   OPCODE_PTR(GETGLOBAL),</span>
<span class="gi">+   OPCODE_PTR(GETTABLE),</span>
<span class="gi">+   OPCODE_PTR(SETGLOBAL),</span>
<span class="gi">+   OPCODE_PTR(SETUPVAL),</span>
<span class="gi">+   OPCODE_PTR(SETTABLE),</span>
<span class="gi">+   OPCODE_PTR(NEWTABLE),</span>
<span class="gi">+   OPCODE_PTR(SELF),</span>
<span class="gi">+   OPCODE_PTR(ADD),</span>
<span class="gi">+   OPCODE_PTR(SUB),</span>
<span class="gi">+   OPCODE_PTR(MUL),</span>
<span class="gi">+   OPCODE_PTR(DIV),</span>
<span class="gi">+   OPCODE_PTR(MOD),</span>
<span class="gi">+   OPCODE_PTR(POW),</span>
<span class="gi">+   OPCODE_PTR(UNM),</span>
<span class="gi">+   OPCODE_PTR(NOT),</span>
<span class="gi">+   OPCODE_PTR(LEN),</span>
<span class="gi">+   OPCODE_PTR(CONCAT),</span>
<span class="gi">+   OPCODE_PTR(JMP),</span>
<span class="gi">+   OPCODE_PTR(EQ),</span>
<span class="gi">+   OPCODE_PTR(LT),</span>
<span class="gi">+   OPCODE_PTR(LE),</span>
<span class="gi">+   OPCODE_PTR(TEST),</span>
<span class="gi">+   OPCODE_PTR(TESTSET),</span>
<span class="gi">+   OPCODE_PTR(CALL),</span>
<span class="gi">+   OPCODE_PTR(TAILCALL),</span>
<span class="gi">+   OPCODE_PTR(RETURN),</span>
<span class="gi">+   OPCODE_PTR(FORLOOP),</span>
<span class="gi">+   OPCODE_PTR(FORPREP),</span>
<span class="gi">+   OPCODE_PTR(TFORLOOP),</span>
<span class="gi">+   OPCODE_PTR(SETLIST),</span>
<span class="gi">+   OPCODE_PTR(CLOSE),</span>
<span class="gi">+   OPCODE_PTR(CLOSURE),</span>
<span class="gi">+   OPCODE_PTR(VARARG)</span>
<span class="gi">+  };</span>
<span class="gi">+#endif</span>
  reentry:  /* entry point */
   lua_assert(isLua(L-&gt;ci));
   pc = L-&gt;savedpc;
<span class="gu">@@ -596,33 +650,33 @@ void luaV_execute (lua_State *L, int nex</span>
     lua_assert(base == L-&gt;base &amp;&amp; L-&gt;base == L-&gt;ci-&gt;base);
     lua_assert(base &lt;= L-&gt;top &amp;&amp; L-&gt;top &lt;= L-&gt;stack + L-&gt;stacksize);
     lua_assert(L-&gt;top == L-&gt;ci-&gt;top || luaG_checkopenop(i));
<span class="gd">-    switch (GET_OPCODE(i)) {</span>
<span class="gd">-      case OP_MOVE: {</span>
<span class="gi">+    CALL_OPCODE(GET_OPCODE(i)) {</span>
<span class="gi">+      OPCODE_TARGET(MOVE) {</span>
         setobjs2s(L, ra, RB(i));
         continue;
       }
<span class="gd">-      case OP_LOADK: {</span>
<span class="gi">+      OPCODE_TARGET(LOADK) {</span>
         setobj2s(L, ra, KBx(i));
         continue;
       }
<span class="gd">-      case OP_LOADBOOL: {</span>
<span class="gi">+      OPCODE_TARGET(LOADBOOL) {</span>
         setbvalue(ra, GETARG_B(i));
         if (GETARG_C(i)) pc++;  /* skip next instruction (if C) */
         continue;
       }
<span class="gd">-      case OP_LOADNIL: {</span>
<span class="gi">+      OPCODE_TARGET(LOADNIL) {</span>
         TValue *rb = RB(i);
         do {
           setnilvalue(rb--);
         } while (rb &gt;= ra);
         continue;
       }
<span class="gd">-      case OP_GETUPVAL: {</span>
<span class="gi">+      OPCODE_TARGET(GETUPVAL) {</span>
         int b = GETARG_B(i);
         setobj2s(L, ra, cl-&gt;upvals[b]-&gt;v);
         continue;
       }
<span class="gd">-      case OP_GETGLOBAL: {</span>
<span class="gi">+      OPCODE_TARGET(GETGLOBAL) {</span>
         TValue g;
         TValue *rb = KBx(i);
         sethvalue(L, &amp;g, cl-&gt;env);
<span class="gu">@@ -630,88 +684,88 @@ void luaV_execute (lua_State *L, int nex</span>
         Protect(luaV_gettable(L, &amp;g, rb, ra));
         continue;
       }
<span class="gd">-      case OP_GETTABLE: {</span>
<span class="gi">+      OPCODE_TARGET(GETTABLE) {</span>
         Protect(luaV_gettable(L, RB(i), RKC(i), ra));
         continue;
       }
<span class="gd">-      case OP_SETGLOBAL: {</span>
<span class="gi">+      OPCODE_TARGET(SETGLOBAL) {</span>
         TValue g;
         sethvalue(L, &amp;g, cl-&gt;env);
         lua_assert(ttisstring(KBx(i)));
         Protect(luaV_settable(L, &amp;g, KBx(i), ra));
         continue;
       }
<span class="gd">-      case OP_SETUPVAL: {</span>
<span class="gi">+      OPCODE_TARGET(SETUPVAL) {</span>
         UpVal *uv = cl-&gt;upvals[GETARG_B(i)];
         setobj(L, uv-&gt;v, ra);
         luaC_barrier(L, uv, ra);
         continue;
       }
<span class="gd">-      case OP_SETTABLE: {</span>
<span class="gi">+      OPCODE_TARGET(SETTABLE) {</span>
         Protect(luaV_settable(L, ra, RKB(i), RKC(i)));
         continue;
       }
<span class="gd">-      case OP_NEWTABLE: {</span>
<span class="gi">+      OPCODE_TARGET(NEWTABLE) {</span>
         int b = GETARG_B(i);
         int c = GETARG_C(i);
         sethvalue(L, ra, luaH_new(L, luaO_fb2int(b), luaO_fb2int(c)));
         Protect(luaC_checkGC(L));
         continue;
       }
<span class="gd">-      case OP_SELF: {</span>
<span class="gi">+      OPCODE_TARGET(SELF) {</span>
         StkId rb = RB(i);
         setobjs2s(L, ra+1, rb);
         Protect(luaV_gettable(L, rb, RKC(i), ra));
         continue;
       }
<span class="gd">-      case OP_ADD: {</span>
<span class="gi">+      OPCODE_TARGET(ADD) {</span>
         TValue *rb = RKB(i), *rc= RKC(i);
         arith_op_continue( luai_numadd, try_addint, luai_vectadd );
         Protect(Arith(L, ra, rb, rc, TM_ADD)); \
         continue;
       }
<span class="gd">-      case OP_SUB: {</span>
<span class="gi">+      OPCODE_TARGET(SUB) {</span>
         TValue *rb = RKB(i), *rc= RKC(i);
         arith_op_continue( luai_numsub, try_subint, luai_vectsub );
         Protect(Arith(L, ra, rb, rc, TM_SUB));
         continue;
       }
<span class="gd">-      case OP_MUL: {</span>
<span class="gi">+      OPCODE_TARGET(MUL) {</span>
         TValue *rb = RKB(i), *rc= RKC(i);
         arith_op_continue(luai_nummul, try_mulint, luai_vectmul);
         Protect(Arith(L, ra, rb, rc, TM_MUL));
         continue;
       }
<span class="gd">-      case OP_DIV: {</span>
<span class="gi">+      OPCODE_TARGET(DIV) {</span>
         TValue *rb = RKB(i), *rc= RKC(i);
         arith_op_continue(luai_numdiv, try_divint, luai_vectdiv);
         Protect(Arith(L, ra, rb, rc, TM_DIV));
         continue;
       }
<span class="gd">-      case OP_MOD: {</span>
<span class="gi">+      OPCODE_TARGET(MOD) {</span>
         TValue *rb = RKB(i), *rc= RKC(i);
         arith_op_continue_scalar(luai_nummod, try_modint);  /* scalars only */
         Protect(Arith(L, ra, rb, rc, TM_MOD));
         continue;
       }
<span class="gd">-      case OP_POW: {</span>
<span class="gi">+      OPCODE_TARGET(POW) {</span>
         TValue *rb = RKB(i), *rc= RKC(i);
         arith_op_continue(luai_numpow, try_powint, luai_vectpow);
         Protect(Arith(L, ra, rb, rc, TM_POW));
         continue;
       }
<span class="gd">-      case OP_UNM: {</span>
<span class="gi">+      OPCODE_TARGET(UNM) {</span>
         TValue *rb = RB(i);
         arith_op1_continue(luai_numunm, try_unmint, luai_vectunm);
         Protect(Arith(L, ra, rb, rb, TM_UNM));
         continue;
       }
<span class="gd">-      case OP_NOT: {</span>
<span class="gi">+      OPCODE_TARGET(NOT) {</span>
         int res = l_isfalse(RB(i));  /* next assignment may change this value */
         setbvalue(ra, res);
         continue;
       }
<span class="gd">-      case OP_LEN: {</span>
<span class="gi">+      OPCODE_TARGET(LEN) {</span>
         const TValue *rb = RB(i);
         switch (ttype(rb)) {
           case LUA_TTABLE: {
<span class="gu">@@ -731,18 +785,18 @@ void luaV_execute (lua_State *L, int nex</span>
         }
         continue;
       }
<span class="gd">-      case OP_CONCAT: {</span>
<span class="gi">+      OPCODE_TARGET(CONCAT) {</span>
         int b = GETARG_B(i);
         int c = GETARG_C(i);
         Protect(luaV_concat(L, c-b+1, c); luaC_checkGC(L));
         setobjs2s(L, RA(i), base+b);
         continue;
       }
<span class="gd">-      case OP_JMP: {</span>
<span class="gi">+      OPCODE_TARGET(JMP) {</span>
         dojump(L, pc, GETARG_sBx(i));
         continue;
       }
<span class="gd">-      case OP_EQ: {</span>
<span class="gi">+      OPCODE_TARGET(EQ) {</span>
         TValue *rb = RKB(i);
         TValue *rc = RKC(i);
         Protect(
<span class="gu">@@ -752,7 +806,7 @@ void luaV_execute (lua_State *L, int nex</span>
         pc++;
         continue;
       }
<span class="gd">-      case OP_LT: {</span>
<span class="gi">+      OPCODE_TARGET(LT) {</span>
         Protect(
           if (luaV_lessthan(L, RKB(i), RKC(i)) == GETARG_A(i))
             dojump(L, pc, GETARG_sBx(*pc));
<span class="gu">@@ -760,7 +814,7 @@ void luaV_execute (lua_State *L, int nex</span>
         pc++;
         continue;
       }
<span class="gd">-      case OP_LE: {</span>
<span class="gi">+      OPCODE_TARGET(LE) {</span>
         Protect(
           if (lessequal(L, RKB(i), RKC(i)) == GETARG_A(i))
             dojump(L, pc, GETARG_sBx(*pc));
<span class="gu">@@ -768,13 +822,13 @@ void luaV_execute (lua_State *L, int nex</span>
         pc++;
         continue;
       }
<span class="gd">-      case OP_TEST: {</span>
<span class="gi">+      OPCODE_TARGET(TEST) {</span>
         if (l_isfalse(ra) != GETARG_C(i))
           dojump(L, pc, GETARG_sBx(*pc));
         pc++;
         continue;
       }
<span class="gd">-      case OP_TESTSET: {</span>
<span class="gi">+      OPCODE_TARGET(TESTSET) {</span>
         TValue *rb = RB(i);
         if (l_isfalse(rb) != GETARG_C(i)) {
           setobjs2s(L, ra, rb);
<span class="gu">@@ -783,7 +837,7 @@ void luaV_execute (lua_State *L, int nex</span>
         pc++;
         continue;
       }
<span class="gd">-      case OP_CALL: {</span>
<span class="gi">+      OPCODE_TARGET(CALL) {</span>
         int b = GETARG_B(i);
         int nresults = GETARG_C(i) - 1;
         if (b != 0) L-&gt;top = ra+b;  /* else previous instruction set top */
<span class="gu">@@ -804,7 +858,7 @@ void luaV_execute (lua_State *L, int nex</span>
           }
         }
       }
<span class="gd">-      case OP_TAILCALL: {</span>
<span class="gi">+      OPCODE_TARGET(TAILCALL) {</span>
         int b = GETARG_B(i);
         if (b != 0) L-&gt;top = ra+b;  /* else previous instruction set top */
         L-&gt;savedpc = pc;
<span class="gu">@@ -836,7 +890,7 @@ void luaV_execute (lua_State *L, int nex</span>
           }
         }
       }
<span class="gd">-      case OP_RETURN: {</span>
<span class="gi">+      OPCODE_TARGET(RETURN) {</span>
         int b = GETARG_B(i);
         if (b != 0) L-&gt;top = ra+b-1;
         if (L-&gt;openupval) luaF_close(L, base);
<span class="gu">@@ -851,7 +905,7 @@ void luaV_execute (lua_State *L, int nex</span>
           goto reentry;
         }
       }
<span class="gd">-      case OP_FORLOOP: {</span>
<span class="gi">+      OPCODE_TARGET(FORLOOP) {</span>
         /* If start,step and limit are all integers, we don&#39;t need to check
          * against overflow in the looping.
          */
<span class="gu">@@ -879,7 +933,7 @@ void luaV_execute (lua_State *L, int nex</span>
         }
         continue;
       }
<span class="gd">-      case OP_FORPREP: {</span>
<span class="gi">+      OPCODE_TARGET(FORPREP) {</span>
         const TValue *init = ra;
         const TValue *plimit = ra+1;
         const TValue *pstep = ra+2;
<span class="gu">@@ -902,7 +956,7 @@ void luaV_execute (lua_State *L, int nex</span>
         dojump(L, pc, GETARG_sBx(i));
         continue;
       }
<span class="gd">-      case OP_TFORLOOP: {</span>
<span class="gi">+      OPCODE_TARGET(TFORLOOP) {</span>
         StkId cb = ra + 3;  /* call base */
         setobjs2s(L, cb+2, ra+2);
         setobjs2s(L, cb+1, ra+1);
<span class="gu">@@ -918,7 +972,7 @@ void luaV_execute (lua_State *L, int nex</span>
         pc++;
         continue;
       }
<span class="gd">-      case OP_SETLIST: {</span>
<span class="gi">+      OPCODE_TARGET(SETLIST) {</span>
         int n = GETARG_B(i);
         int c = GETARG_C(i);
         int last;
<span class="gu">@@ -940,11 +994,11 @@ void luaV_execute (lua_State *L, int nex</span>
         }
         continue;
       }
<span class="gd">-      case OP_CLOSE: {</span>
<span class="gi">+      OPCODE_TARGET(CLOSE) {</span>
         luaF_close(L, ra);
         continue;
       }
<span class="gd">-      case OP_CLOSURE: {</span>
<span class="gi">+      OPCODE_TARGET(CLOSURE) {</span>
         Proto *p;
         Closure *ncl;
         int nup, j;
<span class="gu">@@ -964,7 +1018,7 @@ void luaV_execute (lua_State *L, int nex</span>
         Protect(luaC_checkGC(L));
         continue;
       }
<span class="gd">-      case OP_VARARG: {</span>
<span class="gi">+      OPCODE_TARGET(VARARG) {</span>
         int b = GETARG_B(i) - 1;
         int j;
         CallInfo *ci = L-&gt;ci;
</pre></div>
</code></pre></td></tr></table>
</div> <!-- class=content -->
<div class='footer'>generated by <a href='https://git.zx2c4.com/cgit/about/'>cgit v1.2.3</a> (<a href='https://git-scm.com/'>git 2.25.1</a>) at 2026-02-19 12:19:16 +0000</div>
</div> <!-- id=cgit -->
</body>
</html>
